@echo off
cd %~dp0
setlocal enabledelayedexpansion
title Windows 7 Network Flyout for Windows 10 Installer

:: Variables
set VAN_LOCALE=en-US
set VAN_FILES=dui77.dll pnidui.dll qutil.dll van.dll wcnwiz.dll wlanconn.dll wlandlg.dll wlanmm.dll wlanpref.dll wwanconn.dll xwizards.dll xwtpdui.dll

if "%~1" == "/locale" (
    if NOT "%~2" == "" (
        set VAN_LOCALE=%2
    )
)

:: Texts
cls
echo.
echo Windows 7 Network Flyout for Windows 10
echo ==========================================================================
echo.

:: Check for admin.
net session >nul 2>&1
if NOT %ERRORLEVEL% == 0 (
    goto noadmin
)

echo This batch script will replace system files to restore the network flyout
echo from Windows 7 in Windows 10. Only MUIs for en-US are provided by default.
echo If you want to install this for another locale, grab those files from Windows
echo 7, create a new folder with the locale code in "files", and put the files in
echo there.
echo.
echo   Locale to install: %VAN_LOCALE%
echo.
echo If that locale is incorrect, please exit this script and pass your proper locale
echo with the /locale argument.
echo.

choice /n /m "Do you wish to continue? Doing so will replace system files. (Y/N)"

:: User said no
if %ERRORLEVEL% == 2 (
    goto end
)

:: INSTALL
cls

:: Registry
echo.
echo Importing registry keys...
echo.
echo|set /p="Normal keys..."
call regedit /s "%~dp0regs\normal.reg"
echo done.

echo| set /p="TrustedInstaller keys..."
call "%~dp0bin\psexec64" -accepteula -s -i regedit /s "%~dp0regs\trustedinstaller.reg" >nul 2>&1
echo done.

echo.

:: Files
echo Copying files...

:: DLLs
for %%f in (%VAN_FILES%) do call "%~dp0scripts\ownreplace" %%f

:: MUIs
for %%f in (%VAN_FILES%) do call "%~dp0scripts\ownreplace" %VAN_LOCALE%\%%f.mui

echo.
echo The network flyout has been installed! Restart Explorer to show the Windows 7 flyout.
echo.
pause
goto end

:noadmin
echo You must run this script as administrator. Right click the script and click
echo Run as Administrator, and if you need to pass arguments, run it in a Command
echo Prompt window that is running as administrator.
echo.
pause
goto end

:end
cls